{-
 * Uppsala University - 2017 Fall
 * Program Design and Data Structures, 1DL201
 * Exam 2015-03-19, attempted solutions
 * Copyright 2018 Henrik Alfken(Schulze)
 * Inspired by: competition with Madde.
-}


{-
1. Consider the following function.
lookup :: Eq a => a -> AssocList a b -> Maybe b
lookup _ [] = Nothing
lookup k ((x,y):xs) = if x==k then Just y else lookup k xs
Which of the following type declarations will make the above code type-correct?
  (A) type AssocList a b = a -> Maybe b
  (B) type AssocList = (x,y):xs
  (C) type AssocList a b = [(a,Maybe b)]
  (D) type AssocList a b = [(a,b)]
  (E) type AssocList a b = Eq a => Maybe b
Answer: .

-}


{-
2. Suppose you want to define a datatype to model snarps. You have no idea what a
snarp is, but you have been told that there are only three kinds of them:
(i) the grob is a special snarp (that is different from all other snarps),
(ii) every string is a different snarp, and
(iii) one can gister any snarp and any integer to obtain a new snarp.
Which datatype definition would you use?
  (A) data Snarp = Snarp Grob String (Snarp,Integer)
  (B) data Snarp = Grob | Str String | Gister Snarp Integer
  (C) data Snarp = Grob | String | Gister
  (D) data Snarp = Snarp Grob | Snarp String | Snarp Snarp Integer
  (E) data Snarp = Grob Snarp | Str String | Gister Snarp Integer
Answer: .

-}


{-
3. Consider the type of general trees, defined as
data Tree a = Node a [Tree a]
What does the following function f compute?
f (Node a ts) = a : fs ts
fs [] = []
fs (t:ts) = f t ++ fs ts
  (A) The number of nodes in a tree.
  (B) A post-order list of all values in a tree.
  (C) The height of a tree.
  (D) A pre-order list of all values in a tree.
  (E) The sum of all values in a tree.
Answer: .

-}


{-
4. Which of the following trees is a binary search tree?
    https://i.imgur.com/9tIr1Y4.png
  (A)     (B)     (C)     (D)     (E) None of these.
Answer: .

-}


{-
5. The (worst-case) complexity of searching in a binary search tree with n nodes is
  (A) O(n^2)      (B) O(2^n)      (C) O(n)       (D) O(1)      (E) O(log n)
Answer: .

-}


{-
6. Which of the following statements about Abstract Datatypes (ADTs) is false?
  (A) ADTs make it easier to preserve representation invariants.
  (B) Pattern matching is not available on ADTs.
  (C) The client of an ADT is independent of the ADT’s specific representation.
  (D) ADTs support programming to an interface.
  (E) ADTs are more efficient than regular datatypes.
Answer: .

-}


{-
7. Assume that the the module Table includes the following declaration:
-}
{-
module Table(Table, empty, insert, exists, lookup, delete,
iterate, keys, values) where
Client code imports Table using the following import statement:
import qualified Table(empty,insert) as T hiding(exists)
Which additional names does this import statement introduce into the code?
  (A) empty, insert
  (B) T.empty, T.insert
  (C) Table, empty, insert, exists, lookup, delete, iterate, keys, values
  (D) Table, empty, insert, lookup, delete, iterate, keys, values
  (E) empty, insert, T.empty, T.insert
Answer: .

-}


{-
8. Suppose the following numbers are inserted, in the given order, into an initially
empty red-black tree. (Grey=red.)
    https://i.imgur.com/Y1JJ3Yr.png
    22 36 84 92 24 5 15 80 98 54
What is the resulting red-black tree?
  (A)       (B)       (C)       (D)       (E) None of these.
Answer: .

-}


{-
9. The (worst-case) complexity of inserting an item into a red-black tree with n nodes is
  (A) O(1)       (B) O(n)       (C) O(2^n)       (D) O(log n)       (E) O(n^2)
Answer: .

-}


{-
10. The function unsafePerformIO :: IO a -> a from module System.IO.Unsafe is con-
sidered unsafe. It can be used to embed imperative code into pure code.
Why is unsafePerformIO considered to be unsafe?
  (A) Using it properly requires advanced programming skills.
  (B) It invalidates Haskell’s optimisations.
  (C) It violates purity.
  (D) It can result in I/O operations occurring in unexpected orders.
  (E) All of the above.
Answer: .

-}


{-
11. Given the following datatype
-}
{-
data Tree a b = Leaf a | Branch b (Tree a b) (Tree a b)
and the following typeclass
class Foo a where
foo :: a -> Int
with the following instances
instance Foo Bool where
foo True = 1
foo False = 0
instance Foo Int where
foo n = n `mod` 5
instance (Foo a, Foo b) => Foo (Tree a b) where
foo (Leaf a) = foo a
foo (Branch a b c) = (foo a + foo b + foo c) `mod` 5
instance Foo a => Foo [a] where
foo l = (sum (map foo l)) `mod` 5
-}
{-
What is the value of
foo $ Branch True (Leaf [1::Int,2,3])
(Branch False (Leaf [0,3]) (Leaf [2,5]))
  (A) 0 (B) 1 (C) 2 (D) 3 (E) 4
Answer: .

-}


{-
12. Consider the following function:
-}
{-
saywhat a b = if a < foo b then show a else show b
What type will Haskell give to this function, where foo is the function belonging
to the type class in the previous question?
  (A) Int -> Int -> String
  (B) (Foo a, Ord a) => Int -> a -> String
  (C) (Show a) => Int -> a -> String
  (D) (Foo a, Show a) => Int -> a -> String
  (E) (Foo a, Ord a, Show a) => Int -> a -> String
Answer: .

-}


{-
13. The purpose of monads in Haskell is:
  (A) to make functional code look like imperative code.
  (B) to enable I/O.
  (C) to introduce the do -notation.
  (D) to enable the mixing of pure and impure computation.
  (E) to take something beautiful and make it ugly.
Answer: .

-}


{-
14. Consider the following interface to a stack datatype:
-}
{-
empty :: Stack a
isEmpty :: Stack a -> Bool
push :: a -> Stack a -> Stack a
top :: Stack a -> a
pop :: Stack a -> Stack a
with the same semantics as considered in class. What is the value of
top $ pop $ push 15 $ push 12 $ push 10 empty
  (A) A stack containing 15 and 12 (B) A stack containing 12 and 10
  (C) 10 (D) 15 (E) 12
Answer: .

-}


{-
15. The following code is broken:
-}
{-
0. broken = do
1. putStrLn $ "Enter "
2. ++ "your "++ "name: "
3. let x = getLine
4. y <- putStrLn "Thank you"
5. x
Running the code in GHCi results in the following:
*Main> broken
Enter your name:
Thank you
Dave
"Dave"
7
-}
{-
The first Dave is the input entered by the user and the second "Dave" is the result
of the function.
Why does Thank you appear before the user inputs his name!?!
Which line is the cause of the bug?
  (A) 1 (B) 2 (C) 3 (D) 4 (E) 5
Answer: .

-}


{-
16. Consider the following hash table of 11 cells, where ⊥ denotes that a cell was never
used and ∆ denotes that the element in a cell has been deleted.
0 1 2 3 4 5 6 7 8 9 10
33 23 57 ∆ 70 ⊥ 6 ⊥ 19 ⊥ 54
Assume that the hash function is h(k) = k mod 11, that open addressing with
linear probing function f(i) = i is used as the conflict resolution method, and that
duplicates are allowed.
In which cell will key 109 be placed?
  (A) 9 (B) 5 (C) 3 (D) 10 (E) Nowhere.
Answer: .

-}


{-
17. Recall that the function random has type -}
{-
 random :: (Random a, RandomGen g) =>
g -> (a, g) . You write the following code to generate three random coin tosses
(where head = True and tails = False ).
import System.Random
threeCoins :: (Bool, Bool, Bool)
threeCoins =
let gen = (mkStdGen 21)
in (fst (random gen), fst (random gen), fst (random gen))
-}
{-
Which of the following sentences best describes threeCoins ?
  (A) Oh dear!
  (B) threeCoins gives the same value each time it is accessed, and the three coins
    are equal to each other.
  (C) threeCoins gives the same value each time it is accessed, but the three coins
    may be different from each other.
  (D) threeCoins generates different values each time it is accessed, but the three
    coins are always equal to each other.
  (E) threeCoins generates different values each time it is accessed, and the three
    coins may be different from each other.
Answer: .

-}


{-
18. The following depicts the under-the-hood structure of a mystery Haskell expression
stored in variable a . The arrows represent references.
10
( , ) a
Which of the following is a possible type of a ?
(A) (Int, Int) (B) (IORef Int, Int) (C) IORef (IORef Int, Int)
(D) IORef (IORef (IORef Int), IORef Int) (E) IORef (IORef Int, IORef Int)
Answer: .

This appears to be a question that is no longer part of the PKD course.
-}


{-
19. Consider the following directed graph:
    https://i.imgur.com/GnHL0bh.png
1
2
6
4
5
3
Which of the following is a valid depth-first search ordering—that is, the order in
which nodes are visited when performing a depth-first search?
(A) 123456 (B) 324516 (C) 135264 (D) 654321 (E) 651342
Answer: .

-}


{-
20. Which of the following corresponds to the adjacency list representation of the graph
from the previous question?
    https://i.imgur.com/2XmyGkF.png
(A)
1 2 3 4 5 6
1 1 1
2 1 1
3 1 1 1
4 1 1
5 1 1 1
6 1 1
(B)
1 2 3 4 5 6
1 1
2 1
3 1 1
4
5 1
6 1 1
(C)
1 3
2 4
3 2, 5
4
5 1
6 4, 5
(D)
1 3, 5
2 3, 4
3 1, 2, 5
4 2, 6
5 3, 1
6 4, 6
(E) (1,3), (3,2), (3,5), (2,4), (6,5), (6,4), (5,1)
Answer: .

-}



{-
Answer: .

-}
{-
Answer: .
-}


-- {-
--  * Uppsala University - 2017 Fall
--  * Program Design and Data Structures, 1DL201
--  * Exam 2016-03-17, attempted solutions
--  * Copyright 2018 Henrik Alfken(Schulze)
--  * Inspired by: competition with Madde.
-- -}
-- 
-- 
-- {- Question 1: Suppose you want to write a physics simulation, where objects move
--   through space. Each object has a speed, given by a value of type Double. Speeds
-- are measured either in meters per second (m/s) or in kilometers per hour (km/h).
-- Which of the following type declarations could you use to make sure that speeds
-- measured in m/s are not confused with speeds measured in km/h?
--   A type Speed = Double
--   B type SpeedMs = Double; type SpeedKmh = Double
--   C data Speed = Ms | Kmh
--   D data Speed = Speed Double
--   E data Speed = Ms Double | Kmh Double
-- Answer: E.
-- 
-- See the lecture slides '15-16-Inductive-Data-Types.pdf', page 30, Geometric Shapes:
--   A type that models circles (of a given radius), squares (of a given side length)
--   and triangles (of three given side lengths):
--     -- INVARIANT: all Doubles are positive
--     data Shape = Circle Double
--     | Square Double
--     | Triangle Double Double Double
-- -}
-- 
-- 
-- {- Question 2: In what order would a post-order traversal process the values in the
--   following binary tree?
--          a
--        /   \
--       b     c
--      / \     \
--     d   e     f
-- (In the tree above, all edges are directed downwards.)
--   A abdecf      B abcdef      C dbeacf      D debfca      E fedcba
-- Answer: D.
-- 
-- See the lecture slides '15-16-Inductive-Data-Types.pdf', page 59, traversals:
--   A traversal of a data structure is a way of processing each element in the data structure 
--   exactly once.
--   For binary trees, we distinguish:
--   · Pre-order traversal: process the root value, then traverse the left
--       subtree, then traverse the right subtree
--   · In-order traversal: traverse the left subtree, then process the root
--       value, then traverse the right subtree
--   · Post-order traversal: traverse the left subtree, then traverse the
--       right subtree, then process the root value
-- 
--   Apply the rule for post-order on the above tree:
--   · The left subtree of node a is bde, of which the left subtree of b is d, and the right
--     subtree of b is e. Hence the post-order of the bde subtree is deb.
--   · The right subtree of node a is cf, of which the left subtree of c is empty, and the right
--     subtree of c is f. Hence the post-order of the cf subtree is fc.
--   · The post-order of the whole tree is the post-order of the left subtree followed by the
--     post-order of the right subtree - and finally node a. Putting it together: debfca.
-- -}
-- 
-- 
-- {- Question 3: Consider the type of general trees, defined as -}
-- data Tree a = Node a [Tree a]
--   deriving (Eq,Show)
-- toInt :: Integral a => a -> Int
-- toInt x = fromIntegral x
-- t = Node (toInt 3) [Node 5 [], Node 2 [Node 13 []], Node 7 []]
-- {- What does the following function (f03) compute? -}
-- {- EXAMPLES:
--     f03 t
--       == 5
-- -}
-- f03 (Node a ts) = 1 + fs03 ts
-- -- where
-- {- EXAMPLES:
--     fs03 [t]
--       == 5
-- -}
-- fs03 [] = 0
-- fs03 (t:ts) = f03 t + fs03 ts
-- {-
--   A The sum of all values in a tree.
--   B The number of nodes in a tree.
--   C The height of a tree.
--   D A post-order list of all values in a tree.
--   E A pre-order list of all values in a tree.
-- Answer: B.
-- 
-- See the lecture slides '15-16-Inductive-Data-Types.pdf', pp 48-65.
--   On each occurrence of another node in the tree, line 72 = <f03 (Node a ts) = 1 + fs03 ts> adds
--   one (1) to a call to the helper function fs03, which in turn calls f03 on the next tree and
--   adds the result to a recursive call of fs03 on the remaining sibling trees. Putting it all 
--   together it means that the function f03 counts the number of nodes in the compound tree
--   (starting at the root).
-- -}
-- {- Remark: replacing the digit <1> in <f03 (Node a ts) = 1 + fs03 ts> with an <a> would produce
--   the sum of all values in the tree. -}
-- {- EXAMPLES:
--     sum03 t
--       == 30
-- -}
-- sum03 (Node a ts) = a + sumAux03 ts
-- -- where
-- {- EXAMPLES:
--     sumAux03 [t]
--       == 30
-- -}
-- sumAux03 [] = 0
-- sumAux03 (t:ts) = sum03 t + sumAux03 ts
-- 
-- 
-- {- Question 4: The (worst-case) complexity of inserting an item into a binary search
--     tree with n nodes is
--   A O(2^n)      B O(n)      C O(1)      D O(n^2)      E O(log n)
-- Answer: B.
-- 
-- See the lecture slides '17-Binary-Search-Trees.pdf', pp 1-25.
--   On page 21 it says:
--   "the complexity of inserting into and searching in binary search trees is O(n) in the worst case".
-- -}
-- 
-- 
-- {- Question 5: Suppose the following numbers are inserted, in the given order, into
--   an initially empty red-black tree. (Grey=red.)
--     29 62 78 10 14 99 31 68
-- What is the resulting red-black tree?
--     https://i.imgur.com/QJZMfhq.png
--   A     B     C     D     E None of these.
-- Answer: A.
-- 
-- See the lecture slides '18-Red-Black-Trees.pdf', pp 7-17.
--   Start with the algorithm on page 7:
--     1. Perform a standard binary-search-tree insertion.
--     2. Color the new node red.
--     3. If there is a red node with a red parent --> rebalance the tree.
--     4. Color the root node black.
--   While rebalancing, apply the rules given on pages 9-14.
-- -}
-- 
-- 
-- {- Question 6: How many nodes does a binomial tree of rank r have?
--   A r       B [lg r] + 1       C (r)       D 2^r       E 1
--                                  (k)
-- Answer: D.
-- See the lecture slides '19-Binomial-Heaps.pdf', page 8:
--   "There are 2^r nodes in the tree."
-- -}
-- 
-- 
-- {- Question 7: Which of the following is a distinguishing feature of abstract data types?
-- (distinguishing: characteristic of one thing or person, so serving to identify it; distinctive.)
--   A Pattern matching.
--   B Hidden implementation details.
--   C More efficient than other kinds of data types.
--   D Polymorphism.
--   E Different constructors representing different kinds of data.
-- Answer: B.
-- 
-- See the lecture slides '20-Abstract-Datatypes.pdf', page 9:
--  "An abstract datatype is an encapsulation mechanism.
--   In general it is composed of several components:
--   ...
--    · An implementation hidden from the client of the data type.
--   ...
--   Data abstraction: a clear separation between the abstract properties of a
--   data type (public) and the concrete details of its implementation (private).
--  "
-- -}
-- 
-- 
-- {- Question 8: What is the result of merging the following two binomial heaps?
--     https://i.imgur.com/zJPfZwZ.png
-- For definition, see the lecture slides '19-Binomial-Heaps.pdf', page 10.
-- Each binomial heap is a collection of binomial trees such that
--  · each tree satisfies the min-heap property (the minimum key in the root); and
--  · the trees have strictly increasing ranks.
-- In this case, the following two heaps are to be merged:
--     73    25                  64      10
--            |      - and -           /  |
--           82                      30  86
--                                    |
--                                   69
-- Solution.
--   Start by merging the two zero-ranked trees containing 64 and 73. Since 64 < 73, we get the
--   following binomial tree as a result:
--     64
--      |
--     73
--   which added with the tree containing 25-82 becomes:
--       25
--     /  |
--   64  82    (since 25 < 64)
--    |
--   73
-- Finally, adding the two trees with 4 elements each becomes:
--               _   10
--             _/  /  |
--           25  30  86
--         /  |   |
--       64  82  69        (since 10 < 25)
--        |
--       73
-- which is the same heap as the one depicted in answer D.
--   A     B     C     D     E None of these.
-- Answer: D.
-- 
-- See the lecture slides '19-Binomial-Heaps.pdf', pp 9-13.
-- 
-- About merging binomial heaps, also see:
-- https://brilliant.org/wiki/binomial-heap/#binomial-trees
-- https://brilliant.org/wiki/binomial-heap/#binomial-heaps
--   and then scroll down to "Merging Binomial Heaps".
--   This is a 'brilliant' explanation on how to merge two heaps. :P
-- -}
-- 
-- 
-- {- Question 9: Which of the following best describes the concept of overloading?
--   A Two or more functions with the same name but different definitions.
--   B Two or more functions with different definitions.
--   C Two or more functions with the same definition.
--   D Computationally-intensive functions that overload the CPU.
--   E Polymorphic functions.
-- Answer: A.
-- 
-- See the lecture slides '20-Abstract-Datatypes.pdf', pp 44-78. Page 56:
--   "Overloading allows code to use the same name for functions of different type
--    and different implementations."
-- 
-- (Not sure why E cannot be considered a correct answer? Page 56 of the slides:
--   "Overloading is a kind of polymorphism called ad hoc polymorphism.")
-- -}
-- 
-- 
-- {- Question 10: Which of the following, when executed from within a Haskell program,
--     is NOT a side-effect?
--   A Writing 'one does not simply walk into Mordor' to the screen.
--   B Halting the program with an <EverWatchfulEye> error.
--   C Playing Soundgarden’s 'Spoonman' through the speakers.
--   D Recursively calculating the number of times the phrase
--     'there is evil there that does not sleep' occurs in a string.
--   E Reading Tolkien’s 'The Lord of the Rings' from a text file.
-- Answer: D.
-- 
-- See the lecture slides '22-Imperative-Programming-I.pdf', pp 1-11. On page 6 it says:
--   "An expression is called _pure_ if it has no side effects (such as I/O) and
--    given the same argument value(s) always evaluates to the same result."
-- In this case, given that the recursive calculation of a phrase is done on a given string
--   (which is therfore always the same) will always return the same number.
--   (Provided it is implemented correctly.)
-- -}
-- 
-- 
-- {- Question 11:
-- Consider the type class Mirror which has a function mirror :: t -> t whose
-- intention is to produce some kind of mirror image of a data structure.
-- -}
-- class Mirror t where
--   mirror :: t -> t
-- 
-- instance Mirror () where
--   mirror () = ()
-- 
-- instance Mirror Bool where
--   mirror = not
-- instance Mirror Int where
--   mirror n = -n
-- 
-- instance (Mirror a, Mirror b) => Mirror (a,b) where
--   mirror (a,b) = (mirror a, mirror b)
-- 
-- data BTree a b = Leaf a | Branch b (BTree a b) (BTree a b)
--   deriving (Eq,Show)
-- 
-- {- EXAMPLES:
--   mirror $ Branch (True,()) (Leaf [1,2,3]) (Branch (False,()) (Leaf [3,4,5]) (Leaf [5,6,7]))
--     == Branch (False,()) (Branch (True,()) (Leaf [-7,-6,-5]) (Leaf [-5,-4,-3])) (Leaf [-3,-2,-1])
-- -}
-- instance (Mirror a, Mirror b) => Mirror (BTree a b) where
--   mirror (Leaf a) = Leaf (mirror a)
--   mirror (Branch b l r) = Branch (mirror b) (mirror r) (mirror l)
-- 
-- instance Mirror a => Mirror [a] where
--   mirror = reverse . map mirror
-- {- Given the test case -}
-- -- mirror $ Branch (True,()) (Leaf [1,2,3]) (Branch (False,()) (Leaf [3,4,5]) (Leaf [5,6,7]))
-- --   = Branch (False,()) (Branch (True,()) (Leaf [-7,-6,-5]) (Leaf [-5,-4,-3])) (Leaf [-3,-2,-1])
-- {- which of the following is the most reasonable implementation of mirror for BTree?
--   A
--     mirror (Leaf a) = mirror (Leaf a)
--     mirror (Branch b l r) = Branch (mirror b) (mirror r) (mirror l)
--   B
--     mirror (Leaf a) = Leaf (mirror a)
--     mirror (Branch b l r) = Branch (mirror b) (mirror r) (mirror l)
--   C
--     mirror (Leaf a) = Leaf (mirror a)
--     mirror (Branch b l r) = Branch b (mirror l) (mirror r)
--   D
--     mirror (Leaf a) = Leaf a
--     mirror (Branch b l r) = Branch b (mirror l) (mirror r)
--   E
--     mirror (Leaf a) = Leaf (mirror a)
--     mirror (Branch b l r) = Branch b (mirror r) (mirror l)
-- Answer: B.
-- 
-- In A, <mirror (Leaf a) = mirror (Leaf a)> is an infinite loop (no variant!) so it never terminates.
-- For the remaining suggestions, look at the test case!
-- In D, <mirror (Leaf a) = Leaf a> violates <mirror (Leaf [1,2,3])> SHOULD be <(Leaf [-3,-2,-1])>
-- In E, <mirror (Branch b l r) = Branch b (mirror l) (mirror r)> violates that 
--   <mirror $ Branch (True,()) ...> SHOULD become <Branch (False,()) ...>
-- In C, <mirror (Branch b l r) = Branch b (mirror l) (mirror r)> violates that in the mirror
--   the _left_ subtree SHOULD become <(mirror r)>. (It also has the same violation as in E.)
-- To conclude, B is the only the answer that is in accordance with the given test case.
-- -}
-- 
-- 
-- {- Question 12: Which of the following is true about native/truly mutable arrays
--     (the ones in Data.Array.IO) in Haskell?
--   A O(1)-time read, O(1)-time write.
--   B O(logn)-time read, O(1)-time write.
--   C O(logn)-time read, O(logn)-time write.
--   D O(1)-time read, O(logn)-time write.
--   E O(1)-time read, O(n)-time write.
-- Answer: A.
-- 
-- See the lecture slides '24-Imperative-Programming-III.pdf', pp 3-9, notably p 4:
--   "Element i of array is at address a + i — accessible in Θ(1) time."
--   In this case, accessible should be interpreted to mean both read-access _and_ write-access.
-- -}
-- 
-- 
-- {- Question 13: Consider the following code: -}
-- {-
--   main
--   SIDE EFFECTS:
-- ???
-- -}
-- main = do
--   putStrLn $ "13"
--   let x = putStrLn "10"
--   y <- putStr "12"
--   x
--   putStrLn "11"
--   return y
-- {- What is the output (not the result) of evaluating main in ghci?
--   A
--     13
--     1210
--     11
--     12
--   B
--     13
--     12
--     10
--     11
--   C
--     13
--     10
--     12
--     11
--   D
--     13
--     1210
--     11
--   E
--     13
--     10
--     1211
--     12
-- Answer: D.
-- 
-- See the lecture slides '22-Imperative-Programming-I.pdf', pp 13-46.
--   Note that <let x = putStrLn "10"> is not evaluated immediately, which means that the side effect
--   is postponed as well. And since <putStr "12"> does not output a line break, the output is:
-- 13
-- 1210
-- 11
-- -}
-- 
-- 
-- {- Question 14: Assume that a stack contains the entries
--     (top) 12 15 12 16 12 17 (bottom).
-- Which stack is the result of performing the following operations
--     pop, pop, push 12, pop, pop, push 12 ?
--   A 12 15 12 12
--   B 12 17 12 12
--   C 12 12 12 15
--   D 12 12 12 12
--   E 12 16 12 17
-- Answer: E.
-- 
-- See the lecture slides '20-Abstract-Datatypes.pdf', p 31.
--   Just do each operation one at a time and write what the stack looks like:
--     (top) 12 15 12 16 12 17 (bottom)
--   pop
--     (top) 15 12 16 12 17 (bottom)
--   pop
--     (top) 12 16 12 17 (bottom)
--   push 12
--     (top) 12 12 16 12 17 (bottom)
--   pop
--     (top) 12 16 12 17 (bottom)
--   pop
--     (top) 16 12 17 (bottom)
--   push 12
--     (top) 12 16 12 17 (bottom)
-- -}
-- 
-- 
-- {- Question 15: Given a hashtable with 7 slots that contain, respectively,
--   chains of length 1, 2, 0, 0, 3, 1, 0. That is, slot 0 contains a chain of length 1, slot 1
-- contains a chain of length 2, slot 3 is empty, etc. Keys are numbers and the hash function is
--     hash(key) = key mod 7.
-- What is the length of the longest chain after inserting the numbers 12, 16, 34, 7, 15, 21, 22,
-- assuming that none of these keys already appear in the table?
--   A 3       B 4       C 5       D 6       E 7
-- Answer: B.
-- 
-- See the lecture slides '24-Imperative-Programming-III.pdf', pp 10-24.
--   As in the previous exercise, just insert each number one at a time and write what the hash table
-- looks like, remembering that that hash table is indexed starting with zero:
--     1, 2, 0, 0, 3, 1, 0
--   12 = 7 + 5
--     1, 2, 0, 0, 3, 2, 0
--   16 = 2·7 + 2
--     1, 2, 1, 0, 3, 2, 0
--   34 = 4·7 + 6
--     1, 2, 1, 0, 3, 2, 1
--    7 = 7 + 0
--     2, 2, 1, 0, 3, 2, 1
--   15 = 2·7 + 1
--     2, 3, 1, 0, 3, 2, 1
--   21 = 3·7 + 0
--     3, 3, 1, 0, 3, 2, 1
--   22 = 3·7 + 1
--     3, 4, 1, 0, 3, 2, 1
-- We see that the longest chain is for numbers ending with 2, and that the length is 4.
-- -}
-- 
-- 
-- {- Question 16:
-- Consider the following hash table of 11 cells, where ⊥ denotes that a cell was never used.
--    0   1   2   3   4   5   6   7   8   9  10
--   33  23  57  35  70   ⊥   6   ⊥  19   ⊥  54
-- Assume that the hash function is h(k) = k mod 11, that open addressing with linear probing
--   function f(i) = i
-- is used as the conflict resolution method, and that duplicates are allowed.
-- Firstly, 35 is deleted from the hash table. In which cell of the resulting table will 89 be placed?
--   A Nowhere       B 3       C 5       D 9       E 10
-- Answer: B.
-- 
-- See the lecture slides '24-Imperative-Programming-III.pdf', pp 16-21, notably pp 19-21.
--   The number k represents the element to be inserted, where h(k,i) = (h'(k) + f(i)) mod m
--   is the (calculated) slot in the hash table for where to put element k, given the hash
--   function h'(k) and the probing number i. In this case, h'(k) = k and m = 11.
-- 
--   After the deletion of 35 = 3·11 + 2, the hash table will look as:
--     0   1   2   3   4   5   6   7   8   9  10
--     33  23  57   ∆  70   ⊥   6   ⊥  19   ⊥  54
--   Next, 89 = 8·11 + 1 collides with 23 for i=0, and with 57 for i=1, but t[3] = ∆ for i=2, so:
--     0   1   2   3   4   5   6   7   8   9  10
--     33  23  57  89  70   ⊥   6   ⊥  19   ⊥  54
--   which shows that 89 is inserted in slot 3.
-- -}
-- 
-- 
-- {- Question 17: Consider the following graph:
--     https://i.imgur.com/SogvXTn.png
-- Which of the following is a valid adjacency list representation of the graph?
--   A       B       C       D       E
-- Answer: E.
-- 
-- See the lecture slides '25-26-Graph-Algorithms.pdf', pp 3-18, notably page 17.
--   Note that D gives an edge list and not an adjacency list. Similarly, answers A and B give
--   adjacency matrices and not _lists_. Answer C would have been a valid adjacency list IF the
--   graph had been UNdirected. On each line in answer E, the source node is to the left of the
--   vertical bar, while the valid destination nodes are to the right of it.
--   (You may note, for example, that from node 4 the graph does not allow you to go anywhere,
--   so the list of destinations is empty.)
-- -}
-- 
-- 
-- {- Question 18: Consider the graph from the previous question. Which of the following
-- is a valid depth-first search ordering—that is, the order in which nodes are visited
-- when performing a depth-first search?
--   A 154326        B 156342        C 324561        D 623451        E 635214
-- Answer: C.
-- 
-- See the lecture slides '25-26-Graph-Algorithms.pdf', pp 51-70.
--   The algorithm is on page 53:
--     DFS(G)
--       1. Paint all nodes white.
--       2. For each node v in G: if v is (still) white, DFS-Visit(G,v).
--     Each subsequent call to DFS-Visit in line 2 is called a restart.
-- 
--     DFS-Visit(G,v)
--       1. Colour v gray.
--       2. For each node u adjacent to v: if u is white, DFS-Visit(G,u).
--       3. Colour v black — this node is finished.
-- 
-- Solution.
--   In general, a depth-first search traversal is NOT unique, so there is no way of finding
--   _the_one_and_only_ DFS-ordering. So let us instead try them out one at a time.
--   A 154326
--       15 starts OK, but the next node SHOULD have been 6 which it is not.
--   B 156342
--       1563 starts OK, but the next node SHOULD have been 2 which it is not.
--   C 324561
--       DFS-visit 3: colour 3 gray
--         DFS-visit 2: colour 2 gray
--           DFS-visit 4: colour 4 gray and then black
--         Colour 2 black
--         DFS-visit 5: colour 5 gray
--           DFS-visit 6: colour 6 gray and then black
--             (because we have already been at node 3 so it is no longer white)
--         Colour 5 black
--       Colour 3 black
--       At this point we have visited all nodes and painted them black except for node 1
--       which is still white. Note that we could not reach node 1 when starting from node 3,
--       so we need to restart:
--       - Restart -
--       DFS-visit 1: colour 1 gray and then black
--         (because neither node 4 nor node 5 are white any more.)
--       At this point we can confirm that 324561 is indeed a DFS-ordering, and we could stop here.
--   D 623451
--       6 starts OK, but the next node SHOULD have been 3 which it is not.
--   E 635214
--       6352 starts OK, but the next node SHOULD have been 4 which it is not.
-- -}
-- 
-- 
-- {- Question 19: Consider the following graph:
--     https://i.imgur.com/Qi7bqtz.png
-- Which of the following is a valid topological sort of this graph?
--   A 123456        B 654321        C 243615        D 516342        E 613245
-- Answer: E.
-- 
-- See the lecture slides '25-26-Graph-Algorithms.pdf', pp 19-33.
--   The definition is on page 20:
--     A topological sort is a linear ordering of all the nodes of a directed acyclic graph (DAG).
--     If there is a path from node n_i to node n_j , then n_i appears before n_j in the ordering.
-- 
-- Solution.
--   From the definition we can conclude that:
--     · node 6 must come before all the other nodes. Otherwise there is now way to reach node 6.
--     From this we can rule out all answers except B and E.
--     · node 3 must come before node 2.
--     Both B and E fulfill this requirement.
--     · node 2 must come before node 4.
--     Only E fulfills this requirement.
-- 
-- 
-- --     · node c must come before node f.
-- --   In answer D, f comes before c which violates the topological sort.
-- --   All other answers adhere to the three rules above.
-- 
-- 
-- --   From the definition we can conclude that:
-- --     · node a must come before all the other nodes.
-- --     · node b must come before both d and e.
-- --     · node c must come before node f.
-- --   In answer D, f comes before c which violates the topological sort.
-- --   All other answers adhere to the three rules above.
-- -}
-- 
-- 
-- {- Question 20: Consider the following code that uses exceptions, where
--     <return :: a -> Exceptional a> and <throw :: Exception -> Exceptional a>
-- are used to report good and bad values, respectively. -}
-- data Exception = DivideByZeroException | BadWordException | ConquerByZorroException
--   deriving (Eq,Show)
-- 
-- type Exceptional a = Either Exception a
-- 
-- throw :: Exception -> Exceptional a -- '23-Imperative-Programming-II.pdf', page 9.
-- throw x = Left x
-- 
-- (///) :: Int -> Int -> Exceptional Int
-- _ /// 0 = throw DivideByZeroException
-- a /// b = return $ a `div` b
-- 
-- cleanSentence :: String -> Bool
-- cleanSentence s = and $ (map clean) (words s)
--   where clean s = not (s `elem` ["flip", "jeez", "crumbs"])
-- 
-- censor :: String -> Exceptional String
-- censor s = if cleanSentence s then return s else throw BadWordException
-- 
-- duplicate :: Int -> String -> Exceptional String
-- duplicate n s | n < 0     = throw ConquerByZorroException
-- duplicate n s | otherwise = return $ concat $ replicate n s
-- 
-- {- EXAMPLES:
--     prog 2 (-1) "ingen smuts här"
--       == Left ConquerByZorroException
-- -}
-- prog :: Int -> Int -> String -> Exceptional String
-- prog a b s = do
--   e <- a /// b
--   f <- censor s
--   duplicate e f
-- {- Under what conditions on inputs a, b, and s does function <prog>
-- result in a  <ConquerByZorroException>?
--   A Whenever a is negative and s contains no bad words.
--   B Whenever b is not zero, a `div` b is negative, and s contains no bad words.
--   C Whenever b is not zero, a `mod` b is negative, and s contains no bad words.
--   D Whenever neither a nor b is zero, at most one of a or b is negative,
--     and s contains no bad words.
--   E Whenever neither a nor b is zero, at most one of a or b is negative,
--     and s is not empty and contains no bad words.
-- Answer: B.
-- 
-- See the lecture slides '23-Imperative-Programming-II.pdf', pp 3-16.
--   Note the definition of the function <throw :: Exception -> Exceptional a> on page 9.
-- 
--   For the function <prog> to result in a  <ConquerByZorroException>, it is necessary that
--     (1) <e <- a /// b>  does NOT produce a <DivideByZeroException>
--     (2) <f <- censor s> does NOT produce a <BadWordException>
--     (3) <duplicate e f>   DOES   produce a <ConquerByZorroException>
--   For (1) to hold, it is necessary that b ≠ 0.
--   For (2) to hold, it is necessary that s contains no bad words.
--   For (3) to hold, it is necessary that (a `div` b) < 0. See the lines 598, 600, 579, and 589.
--   To conclude, it is necessary that b ≠ 0, (a `div` b) < 0, and that s contains no bad words.
-- -}
-- 
-- 
-- 
-- {-
-- Answer: .
-- 
-- -}
-- {-
-- Answer: .
-- -}
-- 
-- 
-- 
-- 
-- 
-- 
-- -- {-
-- --  * Uppsala University - 2017 Fall
-- --  * Program Design and Data Structures, 1DL201
-- --  * Exam 2017-03-16, attempted solutions
-- --  * Copyright 2018 Henrik Alfken(Schulze)
-- --  * Inspired by: competition with Madde.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 1: Define a datatype (and any helper types you might need) to represent
-- -- a ticket. A ticket may be:
-- --   • a train ticket from a city to a city—either first or second class; or
-- --   • a bus ticket from a city to a city; or
-- --   • a flight ticket from a city to a city—either business class, super economy, or economy.
-- -- Cities are represented as strings. Which of the following definitions would you use?
-- -- A
-- --   type City = String
-- --   type Economy = SuperEcon | Econ
-- --   data TClass = First | Second
-- --   data FClass = Business | Economy
-- --   data Ticket = Train City City TClass | Bus City City | Flight City City FClass
-- -- B
-- --   type City = String
-- --   data Ticket = Train City City First | Second | Bus City City | Flight City City Business | SuperEcon | Econ
-- -- C
-- --   type City = String
-- --   data TClass = int
-- --   data FClass = String
-- --   data Ticket = Train City City TClass | Bus City City | Flight City City FClass
-- -- D
-- -- -}
-- -- type City = String
-- -- data TClass = First | Second
-- -- data FClass = Business | SuperEcon | Econ
-- -- data Ticket = Train City City TClass | Bus City City | Flight City City FClass
-- -- {-
-- -- E
-- --   type City = String
-- --   type TClass = First | Second
-- --   type FClass = Business | SuperEcon | Econ
-- --   data Ticket = Train City City TClass | Bus City City | Flight City City FClass
-- -- Answer: D.
-- -- 
-- --   In A, <type Economy = SuperEcon | Econ> does not compile.
-- --     <interactive>:13:26: error: parse error on input ‘|’
-- --   In B, <data Ticket = Train City City First> does not compile.
-- --     <interactive>:14:33: error: Not in scope: type constructor or class ‘First’
-- --   In C, <data TClass = int> does not compile.
-- --     <interactive>:19:17: error: Not a data constructor: ‘int’
-- --   In E, <type TClass = First | Second> does not compile.
-- --     <interactive>:21:23: error: parse error on input ‘|’
-- -- See further the lecture slides '15-16-Inductive-Data-Types.pdf', notably pp 8-30.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 2: Consider the type of general trees, defined as -}
-- -- data Tree a = Node a [Tree a]
-- --   deriving (Eq,Show)
-- -- toInt :: Integral a => a -> Int
-- -- toInt x = fromIntegral x
-- -- t = Node (toInt 3) [Node 5 [], Node 2 [Node 13 []], Node 7 []]
-- -- {- What does the following function (f02) compute? -}
-- -- {- EXAMPLES:
-- --     f02 (Node 11 [t])
-- --       == [5,13,2,7,3,11]
-- -- -}
-- -- f02 :: Tree Int -> [Int]
-- -- f02 (Node a ts) = f02s ts ++ [a]
-- -- --   where
-- -- {- EXAMPLES:
-- --     f02s [Node 11 [t]]
-- --       == [5,13,2,7,3,11]
-- -- -}
-- -- f02s [] = []
-- -- f02s (t:ts) = f02 t ++ f02s ts
-- -- {- Hint: what does the following function (pre) compute? -}
-- -- {- EXAMPLES:
-- --     pre (Node 11 [t])
-- --       == [11,3,5,2,13,7]
-- -- -}
-- -- pre :: Tree Int -> [Int]
-- -- pre (Node a ts) = a:preChildren ts
-- -- --   where
-- -- {- EXAMPLES:
-- --     preChildren [Node 11 [t]]
-- --       == [11,3,5,2,13,7]
-- -- -}
-- -- preChildren [] = []
-- -- preChildren (t:ts) = pre t ++ preChildren ts
-- -- {-
-- --   A The sum of all values in a tree.
-- --   B A post-order list of all values in a tree.
-- --   C The number of nodes in a tree.
-- --   D A pre-order list of all values in a tree.
-- --   E The height of a tree.
-- -- Answer: B.
-- -- 
-- -- See further the lecture slides '15-16-Inductive-Data-Types.pdf', pp 59-60.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 3: Which of the following trees is a binary search tree?
-- --   A
-- --       2
-- --     /   \
-- --    4     5
-- -- ...
-- --   B      _  9  _
-- --         /       \
-- --        4 _        11
-- --       /   \         \
-- --      2    7         14
-- --          / \        /
-- --         5  8      15
-- --   C
-- --           _ 8 _
-- --         /       \
-- --        4        11
-- --       /  \         \
-- --      2    7        15
-- --          / \        /
-- --         5  9       14
-- --   D
-- --       2
-- --     /   \
-- --    4     11
-- -- ...
-- --   E None of these.
-- -- Answer: E.
-- -- 
-- --   - A and D are obviously not BSTs.
-- --   In B, 15 is on the wrong side of 14.
-- --   In C, 9 is on the wrong side of 8.
-- --   If in B, 14 and 15 would switch places; and if in C, 8 and 9 would switch places
-- --   - then they would both become BSTs. (And in fact, the same BST.)
-- -- See further the lecture slides '17-Binary-Search-Trees.pdf', pp 10-15.
-- -- Note the invariant given on page 13:
-- --   "In any node (Node l x r), x is larger than all the labels
-- --   of nodes in l and smaller than all the labels of nodes in r."
-- -- -}
-- -- 
-- -- 
-- -- {- Question 4: The (worst-case) complexity of searching in a red-black tree with n nodes is
-- --   A O(n)      B O(log n)      C O(2^n)      D O(n^2)      E O(1)
-- -- Answer: B.
-- -- 
-- -- See the lecture slides '18-Red-Black-Trees.pdf', p 7.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 5: Suppose the following numbers are inserted, in the given order,
-- --   into an initially empty red-black tree. (Grey=red.)
-- --     71 28 81 64 21 76 99 63
-- -- What is the resulting red-black tree?
-- --   https://i.imgur.com/WkVfpjm.png
-- --   A     B     C     D     E None of these.
-- -- Answer: C.
-- -- 
-- -- See the lecture slides '18-Red-Black-Trees.pdf', pp 7-17.
-- --   Start with the algorithm on page 7:
-- --     1. Perform a standard binary-search-tree insertion.
-- --     2. Color the new node red.
-- --     3. If there is a red node with a red parent --> rebalance the tree.
-- --     4. Color the root node black.
-- --   While rebalancing, apply the rules given on pages 9-14.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 6: Assume there exists a function sales :: Int -> Int that gives the
-- --   weekly sales from a shop, where weeks are numbered in sequence 1, 2, .... What
-- --   does the function foo06 below compute?
-- -- -}
-- -- sales :: Int -> Int
-- -- sales 1 = 7
-- -- sales 5 = 3
-- -- sales _ = 42
-- -- 
-- -- {- EXAMPLES:
-- --     foo06 5
-- --       == [2,3,4]
-- -- -}
-- -- foo06 n = mW n (sales n) []
-- --   where
-- --     mW n max weeks
-- --       |       n < 1     = weeks
-- --       | sales n > max   = mW (n-1) (sales n) [n]
-- --       | sales n == max  = mW (n-1) max (n:weeks)
-- --       | sales n < max   = mW (n-1) max weeks
-- -- {-
-- --   A The week number with the largest sales in the period 1, ..., n.
-- --   B The list of week numbers with the largest sales in the period 1, ..., n.
-- --   C The list of week numbers in the period 1, ..., n with sales larger than max.
-- --   D The list of week numbers with sales in the interval [n, max].
-- --   E The week number in the period 1, ..., n with sales larger than max.
-- -- Answer: B.
-- -- 
-- --   <max> is just an accumulator (variable) whose vaue is (originally) set by the call
-- --   <mW n (sales n) []> the value of <max> then changes according to what happens in
-- --   the recursive call. In other words, the value of <max> is not given as such, and
-- --   therefore it does not make any sense to relate the answer to the value of <max> as
-- --   is done in the answers C,D,E. The only two remaining possibilities are A and B.
-- --   But the line <| sales n == max  = mW (n-1) max (n:weeks)> says that if more than
-- --   one week has the largest sales, then a list of all such weeks shall be returned.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 7: A heap is a data structure that is commonly used to implement
-- --   A hash tables.    B priority queues.    C graphs.    D search trees.    E stacks.
-- -- Answer: B.
-- -- 
-- -- See the lecture slides '19-Binomial-Heaps.pdf', p 2:
-- --   "A heap can be used to implement a priority queue".
-- -- -}
-- -- 
-- -- 
-- -- {- Question 8: Consider the following binomial heap.
-- --   https://i.imgur.com/zIKXzgk.png
-- -- After its minimum element is extracted, what is the resulting heap?
-- --   A     B     C     D     E None of these.
-- -- Answer: D.
-- -- 
-- -- See the lecture slides '19-Binomial-Heaps.pdf', pp 9-13.
-- --   Note the definition on page 10:
-- --   "A _binomial_heap_ is a list of binomial trees such that each tree satisfies the
-- --   min-heap property (hence the root of each tree contains its minimum key); and
-- --   the trees have strictly increasing ranks."
-- -- 
-- --   A consequence is that the number of elements determines what tree sizes should be
-- --   in the binomial heap. In our example one element is removed from the original heap
-- --   of 13 elements. Thus, 12 elements remain. The decimal number 12 is written 1100 as
-- --   a binary number. The binary number 1100 tells us there are 0 trees of rank 0
-- --   (containing 2^0 elements), 0 trees of rank 1, 1 tree of rank 2 , and 1 tree of
-- --   rank 3 (containing 2^3 elements). In other words, there will be one tree containing
-- --   four elements and another tree containing eight elements. This rules out answers
-- --   A and B. Answer C still has the element 1 which was supposed to be extracted.
-- --   Answer D has the two correct trees containing the right elements and is therefore
-- --   the correct answer.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 9: Which of the following is a disadvantage of Abstract Data Types (ADTs)?
-- --   A Abstract properties of a data type are separated from implementation details.
-- --   B New operations have to be expressed in terms of existing operations.
-- --   C An ADT is a collection of multiple data types.
-- --   D Implementation details are hidden.
-- --   E The implementation of an ADT depends on the specific data representation.
-- -- Answer: B.
-- -- 
-- -- See the lecture slides '20-Abstract-Datatypes.pdf', p 10.
-- --   "Cons. Cannot add new operations, unless they are phrased in terms of existing ones."
-- -- -}
-- -- 
-- -- 
-- -- {- Question 10: Consider the following function bar10: -}
-- -- {- EXAMPLES:
-- --     bar10 [0,1,2,3,4]
-- --       == [0,0,1,2,3,4]
-- --     bar10 ["f00","bAR","f00Bar"]
-- --       == ["f00","f00","bAR","f00Bar"]
-- -- -}
-- -- bar10 :: [a] -> [a]
-- -- bar10 (x:xs) = x:x:xs
-- -- {-
-- -- Which of the following statements is correct?
-- --   A bar10 is a polymorphic function because it accepts lists of any type.
-- --   B bar10 returns the first element of a list.
-- --   C bar10 is both an overloading and a polymorphic function.
-- --   D bar10 overloads the identity function.
-- --   E bar10 is a polymorphic function because it always performs the same operation.
-- -- Answer: A.
-- -- 
-- --   <bar10> returns the argument list with the first element duplicated in the beginning
-- --   of the list. It is true that it is a polymorphic function (since it accepts lists
-- --   of any type).
-- --   'Overloading' refers to reusing a name of a function when the "same" functionality
-- --   is defined for different data types. For example, the (infix) operation (+) may be
-- --   defined for both integers and floats. See the lecture slides
-- --   '06-Local-Declarations-Patterns-Overloading.pdf', pp 14-18.
-- --   Answer E is not related to what it means that a function is polymorphic.
-- -- See further the lecture slides '13-Polymorphism-Higher-Order-Functions.pdf', pp 6-7.
-- --   The identity function mentioned in D is given on page 7.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 11: Which of the following operations necessarily entails side effects in Haskell?
-- --   A Wrapping a value in the Maybe type using the Just constructor.
-- --   B Counting the number of files in the directory where the program is currently being run.
-- --   C Inserting line numbers after each newline in a string.
-- --   D Calculating the sum of the elements of a list.
-- --   E Calling any function that uses monads.
-- -- Answer: B.
-- -- 
-- --   Counting the number of files in the directory where the program is currently being run.
-- --   The result of such a function depends on how many files there are in the current directory.
-- --   In general, this will NOT give the same result every time the function is called and hence
-- --   by definition, the function is impure.
-- -- See the lecture slides '02-Introduction-FP-and-Haskell.pdf', p 34.
-- -- See the lecture slides '22-Imperative-Programming-I.pdf', p 6:
-- --   "An expression is called pure if it has no side effects (such as I/O) and
-- --   given the same argument value(s) _always_evaluates_to_the_same_result_."
-- -- See the lecture slides '22-Imperative-Programming-I.pdf', p 11 - examples.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 12: The function readFile :: FilePath -> IO String reads the contents of a file.
-- -- Which of the following statements is correct?
-- --   A readFile is referentially transparent, because it is always returns the same result.
-- --   B readFile is not referentially transparent, because it may give different results for the same argument.
-- --   C readFile is referentially transparent, because it is always clear what type the argument has.
-- --   D readFile is not referentially transparent, because different arguments may give different results.
-- --   E readFile is not referentially transparent, because no function in the IO monad is referentially transparent.
-- -- Answer: B.
-- -- 
-- -- See the lecture slides '22-Imperative-Programming-I.pdf', pp 8-9.
-- --   This question is closely related to whether there are side effects:
-- --   "An expression is said to be referentially transparent if it can be replaced with its value
-- --   without changing the behaviour of a program.
-- --   In other words, yielding a program that has the same output on the same input".
-- -- https://stackoverflow.com/questions/41096040/why-wrap-an-io-result-in-io-monad/41096524#41096208
-- -- -}
-- -- 
-- -- 
-- -- {- Question 13: Which of the following is not true for arrays
-- -- (the ones in Data.Array.IO that you have seen in the lectures)?
-- --   A Any element of an array can be written in O(1) time.
-- --   B Arrays can only be used inside the IO monad.
-- --   C The size of an array grows and shrinks as elements are added or removed.
-- --   D The elements of an array are all adjacent in memory.
-- --   E Any element of an array can be read in O(1) time.
-- -- Answer: C.
-- -- 
-- -- See the lecture slides '24-Imperative-Programming-III.pdf', pp 3-9, notably p 4:
-- --   "An array is a continuous chunk of memory.
-- --   Address of array is position of first location a.
-- --   Element i of array is at address a + i — accessible in Θ(1) time."
-- --    - The memory spaced reserved for an array is fixed. The only way to make it shrink or grow
-- --    is to create a completely new array.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 14: Consider the following code: -}
-- -- {-
-- --   foobar14
-- --   SIDE EFFECTS:
-- -- ???
-- -- -}
-- -- foobar14 :: IO Int
-- -- foobar14 = do
-- --   putStr "A"
-- --   x <- putStr "B"
-- --   let y = putStr "C"
-- --   return x
-- --   y
-- --   putStrLn "D"
-- --   return 42
-- -- {- What is the output (not the result) when evaluating foobar14?
-- --   A AD
-- --   B ABCD42
-- --   C ABCD
-- --   D ABCBCD
-- --   E ACBD
-- -- Answer: C.
-- -- 
-- -- See the lecture slides '22-Imperative-Programming-I.pdf', pp 13-46.
-- -- In fact, the exact output when calling <foobar14> is:
-- --   ABCD
-- --   42
-- -- But why? - Well, the side effects of the first three lines in the do-clause are to output ABC
-- --   on the screen. <return x> has no side effect and therefore does not output anything.
-- --   The same  is true for the fifth line <y>. The last side effect of <foobar14> is to output D.
-- --   The function <foobar14> finally returns 42 which is then output on the screen. But this last
-- --   output of 42 is output on the screen by ghci, and is not part of _evaluating_ <foobar14>.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 15: Assume that a stack contains the entries
-- --     (top) 1 2 3 4 5 6 (bottom).
-- -- What is the content of the stack if we perform the following operations?
-- --     push 2, pop, pop, push 1, top, push 1, pop
-- --   A 2 1 1 1 2 3 4 5 6
-- --   B 2 3 4 5 6
-- --   C 1 2 3 4 5 6
-- --   D 1 1 2 3 4 5 6
-- --   E 2 1 1 2 3 4 5 6
-- -- Answer: C.
-- -- 
-- -- See the lecture slides '20-Abstract-Datatypes.pdf', p 31.
-- --   Just do each operation one at a time and write what the stack looks like:
-- --     (top) 1 2 3 4 5 6 (bottom)
-- --   push 2
-- --     (top) 2 1 2 3 4 5 6 (bottom)
-- --   pop
-- --     (top) 1 2 3 4 5 6 (bottom)
-- --   pop
-- --     (top) 2 3 4 5 6 (bottom)
-- --   push 1
-- --     (top) 1 2 3 4 5 6 (bottom)
-- --   top
-- --     (top) 1 2 3 4 5 6 (bottom)  -- The stack is unchanged.
-- --   push 1
-- --     (top) 1 1 2 3 4 5 6 (bottom)
-- --   pop
-- --     (top) 1 2 3 4 5 6 (bottom)
-- -- -}
-- -- 
-- -- 
-- -- {- Question 16: Consider a hash table with 20 slots that uses chaining to resolve conflicts.
-- --   What is the maximal possible chain length (worst case) of a single slot when
-- -- the load factor is 3.2?
-- --   A 16
-- --   B 3.2
-- --   C 32
-- --   D 64
-- --   E None of the above; the load factor can never be larger than 1.
-- -- Answer: D.
-- -- 
-- -- See the lecture slides '24-Imperative-Programming-III.pdf', pp 15 & 23.
-- --   The definition is given in '24-Imperative-Programming-III.pdf', page 23:
-- --     The load factor of a hash table with m slots and n elements is  α = n/m
-- -- 
-- --   The maximal possible chain length of a single slot happens when ALL the elements have been
-- --   inserted in the very same slot. 20 slots and a load factor of 3.2 means that there are
-- --   20 x 3.2 = 64 elements.
-- -- 
-- --   When collision resolution is done by chaining, the number of elements in a hash table is not
-- --   limited by the number of slots as is the case for (linear) probing. Thus, nothing prevents
-- --   the load factor from being larger than 1.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 17: Assume you have a hash table of 10 slots using open addressing.
-- --   The hash function of the table is
-- --     h(k,i) = (k + f(i)) mod m
-- --   where m = 10 is the number of slots of the hash table, and i is the probe number.
-- --   Probing is linear:
-- --     f(i) = i
-- --   Insert the following elements
-- --     113,19,155,16,129,43
-- --   and then remove the element 155.
-- -- If we now search for 33, how many times do we have to probe before we know for sure that
-- -- this element is not in the table? Answer with the largest tried value of i.
-- --   A 0     B 1     C 2     D 3     E 4
-- -- Answer: E.
-- -- 
-- -- See the lecture slides '24-Imperative-Programming-III.pdf', pp 16-21, notably pp 19-21.
-- --   The number k represents the element to be inserted, where h(k,i) = (h'(k) + f(i)) mod m
-- --   is the (calculated) slot in the hash table for where to put element k, given the hash
-- --   function h'(k) and the probing number i. In this case, h'(k) = k.
-- -- 
-- --   After the first four insertions, the hash table t is:
-- --       0     1     2     3     4     5     6     7     8     9
-- --       ⊥     ⊥     ⊥   113     ⊥   155    16     ⊥     ⊥    19
-- --   Next, 129 collides with 19 for i = 0, but t[0] = ⊥ for i = 1, so:
-- --       0     1     2     3     4     5     6     7     8     9
-- --     129     ⊥     ⊥   113     ⊥   155    16     ⊥     ⊥    19
-- --   Finally, 43 collides with 113 for i = 0, but t[4] = ⊥ for i = 1, so:
-- --       0     1     2     3     4     5     6     7     8     9
-- --     129     ⊥     ⊥   113    43   155    16     ⊥     ⊥    19
-- --   Delete 155 from t using h'(k) = k mod 10.
-- --   If we would set t[5] = ⊥, then search for a probed number could fail. Hence:
-- --       0     1     2     3     4     5     6     7     8     9
-- --     129     ⊥     ⊥   113    43     ∆    16     ⊥     ⊥    19
-- --   Now search for 33. How many times do we have to probe before we know for sure that
-- --   this element is not in the table? We try with i=0 which gives us 113≠33. For i=1 we get 43≠33.
-- --   Finally, for i=2 we get ∆ but we STILL cannot conclude that 33 is not in the hash table. The
-- --   reason is that - given what the hash table currently looks like - in both slots 5 and 6 there
-- --   COULD have been numbers ending with a 3, of which the '3-number' in slot 5 has been removed.
-- --   Hence, to be completely certain that 33 is not in the table we have to keep searching until we
-- --   reach a ⊥. This happens at slot 7 with i=4.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 18: In what order would a depth-first search, starting at the root, visit
-- --   the nodes in the following binary tree?
-- --          a
-- --        /   \
-- --       b     c
-- --      / \     \
-- --     d   e     f
-- -- (In the tree above, all edges are directed downwards.)
-- --   A abdecf      B abecfd      C abcedf      D abcdef      E acbfed
-- -- Answer: A.
-- -- 
-- -- See the lecture slides '25-26-Graph-Algorithms.pdf', pp 51-70.
-- --   The algorithm is on page 53:
-- --     DFS(G)
-- --       1. Paint all nodes white.
-- --       2. For each node v in G: if v is (still) white, DFS-Visit(G,v).
-- --     Each subsequent call to DFS-Visit in line 2 is called a restart.
-- -- 
-- --     DFS-Visit(G,v)
-- --       1. Colour v gray.
-- --       2. For each node u adjacent to v: if u is white, DFS-Visit(G,u).
-- --       3. Colour v black — this node is finished.
-- -- 
-- -- Solution.
-- --   DFS-visit a: colour a gray
-- --     DFS-visit b: colour b gray
-- --       DFS-visit d: colour d gray and then black
-- --       DFS-visit e: colour e gray and then black
-- --     Colour b black
-- --     DFS-visit c: colour c gray
-- --       DFS-visit f: colour f gray and then black
-- --     Colour c black
-- --   Colour a black
-- --   The depth-first visit order is the order in which the nodes were coloured gray: abdecf
-- --   Side marks:
-- --     · abedcf, acfbde and acfbed are also possible depth-first visit orderings.
-- --     · answers D=abcdef and E=acbfed are valid breadth-first visit orderings.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 19: Consider the binary tree from the previous question.
-- -- Which of the following is NOT a valid topological sort?
-- --   A abcfed      B acfbed      C abdecf      D abdefc      E acbfed
-- -- Answer: D.
-- -- 
-- -- See the lecture slides '25-26-Graph-Algorithms.pdf', pp 19-33.
-- --   The definition is on page 20:
-- --     A topological sort is a linear ordering of all the nodes of a directed acyclic graph (DAG).
-- --     If there is a path from node n_i to node n_j , then n_i appears before n_j in the ordering.
-- -- 
-- -- Solution.
-- --   From the definition we can conclude that:
-- --     · node a must come before all the other nodes.
-- --     · node b must come before both d and e.
-- --     · node c must come before node f.
-- --   In answer D, f comes before c which violates the topological sort.
-- --   All other answers adhere to the three rules above.
-- -- -}
-- -- 
-- -- 
-- -- {- Question 20: Consider the following code that uses exceptions, where
-- --   <return :: a -> Exceptional a> and <throw :: Exception -> Exceptional a>
-- --   are used to report good and bad values, respectively.
-- -- -}
-- -- data Exception = DivideByZeroException
-- --   deriving (Eq,Show)
-- -- 
-- -- type Exceptional a = Either Exception a
-- -- 
-- -- throw :: Exception -> Exceptional a -- '23-Imperative-Programming-II.pdf', page 9.
-- -- throw x = Left x
-- -- 
-- -- (///) :: Int -> Int -> Exceptional Int
-- -- _ /// 0 = throw DivideByZeroException
-- -- a /// b = return (a `div` b)
-- -- 
-- -- {- EXAMPLES:
-- --     foo20 0 2 1
-- --       == Left DivideByZeroException
-- -- -}
-- -- foo20 :: Int -> Int -> Int -> Exceptional Int
-- -- foo20 a b c = do
-- --   e <- a /// b
-- --   c /// e
-- -- 
-- -- {- EXAMPLES:
-- --     bar20 0 2 1
-- --       == 1
-- -- -}
-- -- bar20 :: Int -> Int -> Int -> Int
-- -- bar20 a b c = handler c (foo20 a b c)
-- -- --   where
-- -- {- EXAMPLES:
-- --     handler 1 (Left DivideByZeroException)
-- --       == 1
-- -- -}
-- -- handler :: Int -> Exceptional Int -> Int
-- -- handler d exc =
-- --   case exc of
-- --   Right y -> if   y < 0 then -1
-- --              else y
-- --   Left  _ -> d
-- -- {- What is the result of calling bar20 0 2 1?
-- --   A 2
-- --   B 0
-- --   C 1
-- --   D -1
-- --   E DivideByZeroException
-- -- Answer: C.
-- -- 
-- -- See the lecture slides '23-Imperative-Programming-II.pdf', pp 3-16.
-- -- Note the definition of the function <throw :: Exception -> Exceptional a> on page 9!
-- -- 
-- -- bar20 0 2 1 --> handler 1 (foo20 0 2 1)
-- --   (foo20 0 2 1) -->
-- --     e <- 0 /// 2 --> (0 `div` 2) --> 0
-- --     1 /// e      --> (1 `div` 0) --> throw DivideByZeroException --> Left DivideByZeroException
-- --       handler 1 (Left DivideByZeroException) --> 1
-- -- 
-- -- In short,
-- -- bar20 0 2 1 --> handler 1 (foo20 0 2 1) --> handler 1 (Left DivideByZeroException) --> 1
-- -- -}
-- -- -- https://www.schoolofhaskell.com/school/starting-with-haskell/basics-of-haskell/10_Error_Handling
