{-
 * Uppsala University - 2017 Fall
 * Program Design and Data Structures, 1DL201
 * Exam 2018-03-15, attempted solutions
 * Copyright 2018 Henrik Alfken(Schulze)
 * Inspired by: -
-}


{- Question 20: Consider the following code that uses exceptions, where
    <return :: a -> Exceptional a> and <throw :: Exception -> Exceptional a>
are used to report good and bad values, respectively. -}
data Exception = DivideByZeroException | BadWordException | ConquerByZorroException
  deriving (Eq,Show)

type Exceptional a = Either Exception a

throw :: Exception -> Exceptional a -- '23-Imperative-Programming-II.pdf', page 9.
throw x = Left x

(///) :: Int -> Int -> Exceptional Int
_ /// 0 = throw DivideByZeroException
a /// b = return $ a `div` b

cleanSentence :: String -> Bool
cleanSentence s = and $ (map clean) (words s)
  where clean s = not (s `elem` ["flip", "jeez", "crumbs"])

censor :: String -> Exceptional String
censor s = if cleanSentence s then return s else throw BadWordException

duplicate :: Int -> String -> Exceptional String
duplicate n s | n < 0     = throw ConquerByZorroException
duplicate n s | otherwise = return $ concat $ replicate n s

{- EXAMPLES:
    prog 2 (-1) "ingen smuts här"
      == Left ConquerByZorroException
    prog 1 0 "flip"
-}
prog :: Int -> Int -> String -> Exceptional String
prog a b s = do
  e <- a /// b
  f <- censor s
  duplicate e f
{- What is the result of running <prog 1 0 "flip">?
-}
